VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmPlayoffDraws 
   Caption         =   "Playoff Draws"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4260
   Icon            =   "frmPlayoffDraws.frx":0000
   LinkTopic       =   "Form2"
   MDIChild        =   -1  'True
   ScaleHeight     =   3090
   ScaleWidth      =   4260
   Begin MSComctlLib.ListView lvwPlayoffDraws 
      Height          =   1695
      Left            =   0
      TabIndex        =   0
      Top             =   360
      Width           =   4095
      _ExtentX        =   7223
      _ExtentY        =   2990
      View            =   3
      Arrange         =   1
      LabelEdit       =   1
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   1
      NumItems        =   0
   End
   Begin MSComctlLib.Toolbar tlbIcons 
      Align           =   1  'Align Top
      Height          =   360
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   4260
      _ExtentX        =   7514
      _ExtentY        =   635
      ButtonWidth     =   609
      ButtonHeight    =   582
      AllowCustomize  =   0   'False
      Appearance      =   1
      Style           =   1
      _Version        =   393216
      BeginProperty Buttons {66833FE8-8583-11D1-B16A-00C0F0283628} 
         NumButtons      =   10
         BeginProperty Button1 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Style           =   3
         EndProperty
         BeginProperty Button2 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Key             =   "itemprop"
            Object.ToolTipText     =   "Properties [Enter]"
         EndProperty
         BeginProperty Button3 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Style           =   3
         EndProperty
         BeginProperty Button4 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Key             =   "itemcopy"
            Object.ToolTipText     =   "Copy [Ctrl+C]"
         EndProperty
         BeginProperty Button5 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Key             =   "itempste"
            Object.ToolTipText     =   "Paste [Ctrl+V]"
         EndProperty
         BeginProperty Button6 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Style           =   3
         EndProperty
         BeginProperty Button7 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Key             =   "itemsela"
            Object.ToolTipText     =   "Select All [Ctrl+A]"
         EndProperty
         BeginProperty Button8 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Style           =   3
         EndProperty
         BeginProperty Button9 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Key             =   "itemup"
            Object.ToolTipText     =   "Move Up [Alt+Up]"
         EndProperty
         BeginProperty Button10 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Key             =   "itemdown"
            Object.ToolTipText     =   "Move Down [Alt+Down]"
         EndProperty
      EndProperty
      BorderStyle     =   1
   End
   Begin MSComctlLib.ImageList imlIcons 
      Left            =   3360
      Top             =   2160
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
   End
End
Attribute VB_Name = "frmPlayoffDraws"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public TT As clsTooltip 'used when form.tt referenced?

Private Sub Form_Load()
On Error GoTo Err_
    
Const cDelimiter = ";"
    
Dim objButton As Button
Dim objButtons As Buttons
Dim blnNoIconError As Boolean

If blnHookColumns Then
    mlvwPlayoffDraws_HdrHwnd = FindWindowEx(lvwPlayoffDraws.hwnd, 0, cHdrHwnd, vbNullString)
    Hook mlvwPlayoffDraws_HdrHwnd
End If

Set TT = New clsTooltip
'TT.Style = TTBalloon
TT.Style = TTStandard
'TT.Icon = TTIconInfo

blnNoIconError = False

'SetIcon Me.hwnd, "winlgrey", False

AddImageFileToImageList imlIcons, tiWinLines, tiWinLines
'SetIconTest Me.hwnd, LoadPicture(AppPath() & "\Icons\wboyice.ico", vbLPSmall, vbLPColor)
Call sLoadPicture(Me, tiWinPlyOf)

AddImageFileToImageList imlIcons, tiNoIcon, tiNoIcon

Set tlbIcons.ImageList = imlIcons
        
    Set objButtons = tlbIcons.Buttons
    For Each objButton In objButtons
        If Not objButton.Key = "" Then
            AddImageFileToImageList imlIcons, objButton.Key, objButton.Key
            tlbIcons.Buttons(objButton.Key).Image = objButton.Key
        End If
    Next objButton
    
    Set objButton = Nothing
    Set objButtons = Nothing

Call myListviewLoadColumns(lvwPlayoffDraws, strPlayoffDrawColumnLabels, strPlayoffDrawColumnWidths, Split(strPlayoffDrawColumnLabels, cDelimiter)(0) & cDelimiter & strPlayoffDrawEditLabels) ', 17, strPlayerEditLabels)
Call fPopulatePlayoffDraws

If objfdi(fdiPlayoffDraws).UseValues Then
    Call sFormDimensionRestore(Me, objfdi(fdiPlayoffDraws))
    'Call Form_Resize
Else
    WindowState = vbMinimized
End If

Call lvwPlayoffDraws_ButtonItemClick

lvwPlayoffDraws.Enabled = False

Show

Exit_:
    Exit Sub
    
Err_:
    Select Case Err.Number
    Case 326:
        Resume Next
    Case 35601:
        If Not blnNoIconError Then
            tlbIcons.Buttons(objButton.Key).Image = tiNoIcon
        End If
        Resume Next
    Case 35601: 'ImageList cannot be initialized (missing noicon.ico)
        Resume Next
    Case Else
        MsgBox vbNewLine & Err.Description & vbTab, vbExclamation, Err.Number
        Resume Next
        'Resume Exit_
    End Select
End Sub

Private Sub Form_Resize()
Call myFormResize(Me.lvwPlayoffDraws)
End Sub

Private Sub Form_Unload(Cancel As Integer)


If Not blnMDIApplicationIsUnloading Then
    If blnMDIOpenFileIsBeingClosed Then
        Call sFormDimensionSave(Me, objfdi(fdiPlayoffDraws))
    Else
        Cancel = fMDIChildMinimizeOnClose(Me)
        If Not Cancel Then
            If blnHookColumns Then
                Unhook mlvwPlayoffDraws_HdrHwnd
            End If
        End If
    End If
End If

End Sub

Private Sub lvwPlayoffDraws_Click()
Call lvwPlayoffDraws_ButtonItemClick
End Sub

Private Sub lvwPlayoffDraws_DblClick()
On Error GoTo Err_

Screen.MousePointer = vbHourglass
Load frmPlayoffDrawEdit
frmPlayoffDrawEdit.Show vbModal

Exit_:
Call lvwPlayoffDraws_RequeryLineItem(lvwPlayoffDraws.SelectedItem)
Screen.MousePointer = vbNormal
Exit Sub

Err_:
Select Case Err.Number
    Case 91: '?
        Resume Exit_
    Case 364:
        Resume Exit_
    Case Else:
        fErrMessage Err.Number, Err.Description, "Form_Load"
End Select
'Resume Exit_
Resume Next

End Sub

Private Sub lvwPlayoffDraws_KeyDown(KeyCode As Integer, Shift As Integer)
On Error GoTo Err_

Dim blnCtrlHeld As Boolean
Dim blnAltHeld As Boolean

blnCtrlHeld = (Shift And vbCtrlMask) > 0
blnAltHeld = (Shift And vbAltMask) > 0

Select Case KeyCode
    
    Case hkITEMCOPYCtrl And blnCtrlHeld: ',hkITEMCOPY - Copy Item
        Call tlbIcons_ButtonClick(tlbIcons.Buttons(tiItemCopy))
    
    Case hkITEMPSTECtrl And blnCtrlHeld: ',hkITEMPSTE - Paste Item
            Call tlbIcons_ButtonClick(tlbIcons.Buttons(tiItemPste))
    
    Case hkITEMSELACtrl And blnCtrlHeld: ',hkITEMSELA - Select All
        Call sListViewItemsSelectAll(lvwPlayoffDraws)
        Call lvwPlayoffDraws_ButtonItemClick
    
    Case hkITEMSELICtrl And blnCtrlHeld: ',hkITEMSELA - Invert Selection
        Call sListViewItemsInvertSelection(lvwPlayoffDraws)
        Call lvwPlayoffDraws_ButtonItemClick
    
    Case vbKeyReturn:
        Call lvwPlayoffDraws_DblClick
    
    Case vbKeyDown And blnAltHeld:
        KeyCode = 0
        Call tlbIcons_ButtonClick(tlbIcons.Buttons(tiItemDown))
    
    Case vbKeyUp And blnAltHeld:
        KeyCode = 0
        Call tlbIcons_ButtonClick(tlbIcons.Buttons(tiItemUp))
    

End Select

Exit_:
'DoEvents
Exit Sub

Err_:
fErrMessage Err.Number, Err.Description, "mnuFileExit_Click"
'Resume Exit_
Resume Next

End Sub

Private Sub lvwPlayoffDraws_KeyPress(KeyAscii As Integer)
KeyAscii = 0
End Sub

Private Sub lvwPlayoffDraws_KeyUp(KeyCode As Integer, Shift As Integer)

Select Case KeyCode
        Case vbKeyUp, vbKeyDown, vbKeyHome, vbKeyEnd, vbKeyPageUp, vbKeyPageDown:
            Call lvwPlayoffDraws_ButtonItemClick
End Select

End Sub

Private Sub tlbIcons_ButtonClick(ByVal Button As MSComctlLib.Button)
On Error Resume Next

If Button.Enabled Then 'trap hotkey calls
    Select Case Button.Key
        Case tiItemProp:
            Call lvwPlayoffDraws_KeyDown(vbKeyReturn, False)
            
        Case tiItemSelA:
            Call lvwPlayoffDraws_KeyDown(hkITEMSELACtrl, vbCtrlMask)
        
        Case tiItemUp, tiItemDown:
            Call lvwItem_Move(lvwPlayoffDraws, 16, Button.Key)
            Call lvwPlayoffDraws_ButtonItemClick
    
        Case tiItemCopy, tiItemPste: 'playoff draw
            Call sClipboardCopyPaste(lvwPlayoffDraws, cClipboardPlayoffDraws, Button.Key)
            
    End Select
End If

Exit_:
Exit Sub

End Sub

