VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmRules 
   Caption         =   "Rules"
   ClientHeight    =   3084
   ClientLeft      =   60
   ClientTop       =   456
   ClientWidth     =   4680
   LinkTopic       =   "Form2"
   MDIChild        =   -1  'True
   ScaleHeight     =   3084
   ScaleWidth      =   4680
   Begin MSComctlLib.ListView lvwRules 
      Height          =   1095
      Left            =   0
      TabIndex        =   0
      Top             =   360
      Width           =   4095
      _ExtentX        =   7218
      _ExtentY        =   1926
      View            =   3
      Arrange         =   1
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   1
      NumItems        =   0
   End
   Begin MSComctlLib.Toolbar tlbIcons 
      Align           =   1  'Align Top
      Height          =   288
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   4680
      _ExtentX        =   8255
      _ExtentY        =   508
      ButtonWidth     =   487
      ButtonHeight    =   466
      AllowCustomize  =   0   'False
      Appearance      =   1
      Style           =   1
      _Version        =   393216
      BeginProperty Buttons {66833FE8-8583-11D1-B16A-00C0F0283628} 
         NumButtons      =   2
         BeginProperty Button1 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Style           =   3
         EndProperty
         BeginProperty Button2 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Key             =   "itemprop"
            Object.ToolTipText     =   "Properties [Enter]"
         EndProperty
      EndProperty
      BorderStyle     =   1
   End
   Begin MSComctlLib.ImageList imlIcons 
      Left            =   720
      Top             =   2160
      _ExtentX        =   995
      _ExtentY        =   995
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
   End
End
Attribute VB_Name = "frmRules"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public TT As clsTooltip

Private Sub Form_Load()
On Error GoTo Err_

If blnHookColumns Then
    mlvwRules_HdrHwnd = FindWindowEx(lvwRules.hwnd, 0, cHdrHwnd, vbNullString)
    Hook mlvwRules_HdrHwnd
End If

Set TT = New clsTooltip
'TT.Style = TTBalloon
TT.Style = TTStandard
'TT.Icon = TTIconInfo

Call sLoadPicture(Me, tiWinRules)
Call sLoadToolbarIcons(tlbIcons, imlIcons)
'Call sLoadToolbarState(tlbIcons, False)
Call myListviewLoadColumns(lvwRules, strRuleColumnLabels, strRuleColumnWidths, strRuleEditLabels)
Call fPopulateRules

If objfdi(fdiRules).UseValues Then
    Call sFormDimensionRestore(Me, objfdi(fdiRules))
    'Call Form_Resize
Else
    WindowState = vbMinimized
End If

'Call lvwRules_ButtonItemClick

lvwRules.Enabled = False

Show

Exit_:
    Exit Sub
    
Err_:
    MsgBox vbNewLine & Err.Description & vbTab, vbExclamation, Err.Number
    Resume Next
    'Resume Exit_
End Sub

Private Sub Form_Resize()
Call myFormResize(lvwRules)
End Sub

Private Sub Form_Unload(Cancel As Integer)

If Not blnMDIApplicationIsUnloading Then
    If blnMDIOpenFileIsBeingClosed Then
       Call sFormDimensionSave(Me, objfdi(fdiRules))
    Else
        Cancel = fMDIChildMinimizeOnClose(Me)
        If Not Cancel Then
            If blnHookColumns Then
                Unhook mlvwRules_HdrHwnd
            End If
        End If
    End If
End If

End Sub

'Private Sub lvwRules_Click()

'Call lvwRules_ButtonItemClick

'End Sub

Private Sub lvwRules_DblClick()
On Error GoTo Err_

Screen.MousePointer = vbHourglass
Load frmRuleEdit
frmRuleEdit.Show vbModal


Exit_:
Call lvwRules_RequeryLineItem(lvwRules.SelectedItem)
Screen.MousePointer = vbNormal
Exit Sub

Err_:
Select Case Err.Number
    Case 91: '?
        Resume Exit_
    Case 364:
        Resume Exit_
    Case Else:
        fErrMessage Err.Number, Err.Description, "Form_Load"
End Select
'Resume Exit_
Resume Next

End Sub

Private Sub lvwRules_KeyDown(KeyCode As Integer, Shift As Integer)
On Error GoTo Err_

Select Case KeyCode
    
    Case vbKeyReturn:
        Call lvwRules_DblClick
    
End Select

Exit_:
'DoEvents
Exit Sub

Err_:
fErrMessage Err.Number, Err.Description, "mnuFileExit_Click"
'Resume Exit_
Resume Next
End Sub

Private Sub lvwRules_KeyPress(KeyAscii As Integer)
KeyAscii = 0
End Sub

'Private Sub lvwRules_KeyUp(KeyCode As Integer, Shift As Integer)

'Select Case KeyCode
'    Case vbKeyUp, vbKeyDown
'        Call lvwRules_ButtonItemClick
'End Select

'End Sub

Private Sub tlbIcons_ButtonClick(ByVal Button As MSComctlLib.Button)
Dim KeyCode As Integer

If Button.Enabled Then 'trap hotkey calls
    Select Case Button.Key
        'Case tiGotoPrev:
            'KeyCode = vbKeyUp
        '    Call lvwListItem_Previous(lvwRules)
        '    Call lvwRules_ButtonItemClick
        'Case tiGotoNext:
            'KeyCode = vbKeyDown
        '    Call lvwListItem_Next(lvwRules)
        '    Call lvwRules_ButtonItemClick
        Case tiItemProp:
            KeyCode = vbKeyReturn
            Call lvwRules_KeyDown(KeyCode, False)
    End Select
End If

'Call lvwRules_KeyDown(KeyCode, False)

End Sub
